import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

public class Echtzeit implements Runnable
{
      public Echtzeit()
      {
          ScheduledExecutorService schedExecService;
          schedExecService = Executors.newSingleThreadScheduledExecutor();
          //long ZYKLUS_DAUER_MILLIS = (long)(dt*1000.0);
          long ZYKLUS_DAUER_MILLIS = 1; //immer einmal pro Millisekunde
          
          schedExecService.scheduleAtFixedRate(this, 0, ZYKLUS_DAUER_MILLIS, TimeUnit.MILLISECONDS); 
      }
  
      public void run()
      {
          //Prüfen, ob einer gesiegt hat:
          if(   Math.sqrt(yB_alt[0]*yB_alt[0]+yB_alt[1]*yB_alt[1])>TISCHDURCHMESSER*0.5   )
          {
                SIEG_A = true;
                SIEG_B = false;
                initialisieren();
          }
          else if(   Math.sqrt(yA_alt[0]*yA_alt[0]+yA_alt[1]*yA_alt[1])>TISCHDURCHMESSER*0.5   )
          {
                SIEG_A = false;
                SIEG_B = true;
                initialisieren();                
          }
        
        
          sensorA.aktualisieren();
          sensorB.aktualisieren();
          
          sensorGA.aktualisieren();
          sensorGB.aktualisieren();
 
          setzeKollisionskraft(); //Kollision ermöglichen!
          
          //Intelligentes Verhalten in diesen Methoden festlegen für Sumo A und B:
          schlauA();
          schlauB();
          
          integratorA.zeitschritt(yA,yA_alt, t, dt);    
          integratorB.zeitschritt(yB,yB_alt, t, dt);    
          for(int i=0;i<yA.length;i++)
              yA_alt[i]=yA[i];
          for(int i=0;i<yB.length;i++)
              yB_alt[i]=yB[i];
          t+=dt;        
      }
}
